(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.ely = f()}})(function(){var define,module,exports;return (function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Patterns = exports.ely = exports.Ely = undefined;

var _Ely = require('./mapper/Ely');

var _Ely2 = _interopRequireDefault(_Ely);

var _Patterns = require('./mapper/Patterns');

var _Patterns2 = _interopRequireDefault(_Patterns);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.Ely = _Ely2.default;
exports.ely = _Ely2.default;
exports.Patterns = _Patterns2.default;
},{"./mapper/Ely":2,"./mapper/Patterns":3}],2:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _events = require('events');

var _events2 = _interopRequireDefault(_events);

var _Patterns = require('./Patterns');

var _Patterns2 = _interopRequireDefault(_Patterns);

var _StorageMap = require('./StorageMap');

var _StorageMap2 = _interopRequireDefault(_StorageMap);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Ely
 *
 * Maps and unmaps object properties to emitter.
 * Every further change of properties will emit the changes.
 *
 * Can keep the emitter inside or outside of the original object.
 */
var Ely = function () {
  function Ely() {
    _classCallCheck(this, Ely);
  }

  _createClass(Ely, null, [{
    key: 'mapIn',

    /**
     * Maps and keeps emitter inside the object
     *
     * Shortkey for map(object, true, patterns)
     *
     * @param {Object} object object with properties
     * @param {Patterns} patterns patterns of matching
     * @return {EventEmitter} event emitter
     */
    value: function mapIn(object) {
      var patterns = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : undefined;

      return Ely.map(object, true, patterns);
    }

    /**
     * Maps and keeps emitter outside the object
     *
     * Shortkey for map(object, false, patterns)
     *
     * @param {Object} object object with properties
     * @param {Patterns} patterns patterns of matching
     * @return {EventEmitter} event emitter
     */

  }, {
    key: 'mapOut',
    value: function mapOut(object) {
      var patterns = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : undefined;

      return Ely.map(object, false, patterns);
    }

    /**
     * Maps object properties
     *
     * Main map method
     *
     * @param {Object} object object with properties
     * @param {boolean} embed embed the emitter or not
     * @param {Patterns} patterns patterns of matching
     * @return {EventEmitter} event emitter
     */

  }, {
    key: 'map',
    value: function map(object) {
      var embed = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
      var patterns = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : undefined;

      var defaultPatterns = Ely.defaultPatterns;
      patterns = patterns === undefined ? defaultPatterns : patterns;

      var emitter = void 0;

      if (embed) {
        if (object.ely !== undefined) {
          if (object.ely instanceof _events2.default) {
            emitter = object.ely;
          } else {
            embed = false;
          }
        }
      }

      if (emitter === undefined) {
        emitter = new _events2.default();
      }

      if (embed && object.ely === undefined) {
        Object.defineProperty(object, 'ely', {
          configurable: true,
          enumerable: true,
          writable: false,
          value: emitter
        });
      }

      var elyMapKey = Ely.findElyMapKey(object);
      var elyMap = object[elyMapKey] !== undefined ? object[elyMapKey] : new _StorageMap2.default();
      var elyMapKeys = Object.keys(elyMap.map);
      elyMapKeys.push(elyMapKey);

      var emitall = patterns !== undefined ? patterns.emitall : false;

      Object.keys(object).forEach(function (key) {
        if (elyMapKeys.indexOf(key) === -1) {
          var descriptor = Object.getOwnPropertyDescriptor(object, key);
          if (descriptor.writable) {
            var valueType = _typeof(descriptor.value);
            if (valueType !== 'function') {
              if (patterns === undefined || Ely.match(key, patterns.accept) && Ely.notmatch(key, patterns.skip)) {
                var privateKey = Ely.findEmptyKey(elyMap.map, key, '_');
                var value = object[key];

                Object.defineProperty(elyMap.values, privateKey, {
                  configurable: true,
                  enumerable: true,
                  writable: true,
                  value: value
                });
                Object.defineProperty(object, key, {
                  configurable: true,
                  enumerable: true,
                  set: function set(value) {
                    emitter.emit(key, value, elyMap.values[privateKey]);
                    if (emitall) {
                      emitter.emit('*', value, elyMap.values[privateKey], key);
                    }
                    elyMap.values[privateKey] = value;
                  },
                  get: function get() {
                    return elyMap.values[privateKey];
                  }
                });

                elyMap.map[key] = privateKey;
              }
            }
          }
        }
      });

      Object.defineProperty(object, elyMapKey, {
        configurable: true,
        enumerable: false,
        writable: true,
        value: elyMap
      });

      return emitter;
    }

    /**
     * Unmaps object properties
     *
     * @param {Object} object object with properties
     */

  }, {
    key: 'unmap',
    value: function unmap(object) {
      var elyMapKey = Ely.findElyMapKey(object);
      var elyMap = object[elyMapKey];

      if (elyMap !== undefined) {
        Object.keys(elyMap.map).forEach(function (key) {
          Object.defineProperty(object, key, {
            configurable: true,
            enumerable: true,
            writable: true,
            value: elyMap.values[elyMap.map[key]]
          });
        });

        delete object[elyMapKey];
        if (object['ely'] !== undefined && object['ely'] instanceof _events2.default) {
          delete object['ely'];
        }
      }
    }

    /**
     * Gets default pattern
     *
     * @return {Patterns} default patterns
     */

  }, {
    key: 'findElyMapKey',


    /**
     * Finds the ely map key
     *
     * Checks if default ely map key already exists and replaces
     * it with unique one.
     *
     * @param {Object} object object with properties
     * @return {string}
     * @protected
     */
    value: function findElyMapKey(object) {
      var name = '__ely_map__';
      while (object[name] !== undefined && !(object[name] instanceof _StorageMap2.default)) {
        name = '_' + name + '_';
      }
      if (object[name] === undefined) {
        return name;
      } else if (object[name] instanceof _StorageMap2.default) {
        return name;
      } else {
        return undefined;
      }
    }

    /**
     * Finds empty key
     *
     * Checks if key overlap inside object. Creates unique one if needed.
     *
     * @param {Object} object object with properties
     * @param {string} key key to be checked
     * @param {string} prefix prefix to be applied
     * @return {string} unique key
     * @protected
     */

  }, {
    key: 'findEmptyKey',
    value: function findEmptyKey(object, key, prefix) {
      var name = key;
      while (object[name] !== undefined) {
        name = prefix + name;
      }
      return name;
    }

    /**
     * Matches key to pattern
     *
     * Checks if key matches a given pattern
     *
     * @param {string} key key to be checked
     * @param {Patterns} patterns patterns to check against
     * @return {boolean} match result
     * @protected
     */

  }, {
    key: 'match',
    value: function match(key, patterns) {
      if (patterns === undefined) {
        return true;
      } else if (Array.isArray(patterns)) {
        var length = patterns.length;
        var i = void 0;
        var pass = false;
        for (i = 0; i < length; ++i) {
          var pattern = patterns[i];
          if ((typeof pattern === 'undefined' ? 'undefined' : _typeof(pattern)) === 'object' && pattern.constructor !== undefined && pattern.constructor.name === 'RegExp') {
            pass = pass || pattern.test(key);
          }
        }
        return pass;
      } else if ((typeof patterns === 'undefined' ? 'undefined' : _typeof(patterns)) === 'object' && patterns.constructor !== undefined && patterns.constructor.name === 'RegExp') {
        return patterns.test(key);
      } else {
        return true;
      }
    }

    /**
     * No Matches key to pattern
     *
     * Checks if key does not match a given pattern
     *
     * @param {string} key key to be checked
     * @param {Patterns} patterns patterns to check against
     * @return {boolean} match result
     * @protected
     */

  }, {
    key: 'notmatch',
    value: function notmatch(key, patterns) {
      if (patterns === undefined) {
        return true;
      } else if (Array.isArray(patterns)) {
        var length = patterns.length;
        var i = void 0;
        var pass = false;
        for (i = 0; i < length; ++i) {
          var pattern = patterns[i];
          if ((typeof pattern === 'undefined' ? 'undefined' : _typeof(pattern)) === 'object' && pattern.constructor !== undefined && pattern.constructor.name === 'RegExp') {
            pass = pass || pattern.test(key);
          }
        }
        return !pass;
      } else if ((typeof patterns === 'undefined' ? 'undefined' : _typeof(patterns)) === 'object' && patterns.constructor !== undefined && patterns.constructor.name === 'RegExp') {
        return !patterns.test(key);
      } else {
        return true;
      }
    }
  }, {
    key: 'defaultPatterns',
    get: function get() {
      return new _Patterns2.default(undefined, /^_.*$/, true);
    }
  }]);

  return Ely;
}();

exports.default = Ely;
},{"./Patterns":3,"./StorageMap":4,"events":5}],3:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Patterns
 *
 * Patterns for matching.
 *
 * @param {RegExp} accept regular expression for accept
 * @param {RegExp} skip regular expression for skip
 * @param {boolean} emitall emitall status
 */
var Patterns =
/**
 * Patterns constructor
 *
 * @param {RegExp} accept regular expression for accept
 * @param {RegExp} skip regular expression for skip
 * @param {boolean} emitall emitall status
 */
function Patterns(accept, skip) {
  var emitall = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

  _classCallCheck(this, Patterns);

  this.accept = accept;
  this.skip = skip;
  this.emitall = emitall;
};

exports.default = Patterns;
},{}],4:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * StorageMap
 *
 * Storage map for properties
 * @internal
 */
var StorageMap =
/**
 * StorageMap constructor
 */
function StorageMap() {
  _classCallCheck(this, StorageMap);

  this.map = {};
  this.values = {};
};

exports.default = StorageMap;
},{}],5:[function(require,module,exports){
// Copyright Joyent, Inc. and other Node contributors.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THE SOFTWARE.

function EventEmitter() {
  this._events = this._events || {};
  this._maxListeners = this._maxListeners || undefined;
}
module.exports = EventEmitter;

// Backwards-compat with node 0.10.x
EventEmitter.EventEmitter = EventEmitter;

EventEmitter.prototype._events = undefined;
EventEmitter.prototype._maxListeners = undefined;

// By default EventEmitters will print a warning if more than 10 listeners are
// added to it. This is a useful default which helps finding memory leaks.
EventEmitter.defaultMaxListeners = 10;

// Obviously not all Emitters should be limited to 10. This function allows
// that to be increased. Set to zero for unlimited.
EventEmitter.prototype.setMaxListeners = function(n) {
  if (!isNumber(n) || n < 0 || isNaN(n))
    throw TypeError('n must be a positive number');
  this._maxListeners = n;
  return this;
};

EventEmitter.prototype.emit = function(type) {
  var er, handler, len, args, i, listeners;

  if (!this._events)
    this._events = {};

  // If there is no 'error' event listener then throw.
  if (type === 'error') {
    if (!this._events.error ||
        (isObject(this._events.error) && !this._events.error.length)) {
      er = arguments[1];
      if (er instanceof Error) {
        throw er; // Unhandled 'error' event
      } else {
        // At least give some kind of context to the user
        var err = new Error('Uncaught, unspecified "error" event. (' + er + ')');
        err.context = er;
        throw err;
      }
    }
  }

  handler = this._events[type];

  if (isUndefined(handler))
    return false;

  if (isFunction(handler)) {
    switch (arguments.length) {
      // fast cases
      case 1:
        handler.call(this);
        break;
      case 2:
        handler.call(this, arguments[1]);
        break;
      case 3:
        handler.call(this, arguments[1], arguments[2]);
        break;
      // slower
      default:
        args = Array.prototype.slice.call(arguments, 1);
        handler.apply(this, args);
    }
  } else if (isObject(handler)) {
    args = Array.prototype.slice.call(arguments, 1);
    listeners = handler.slice();
    len = listeners.length;
    for (i = 0; i < len; i++)
      listeners[i].apply(this, args);
  }

  return true;
};

EventEmitter.prototype.addListener = function(type, listener) {
  var m;

  if (!isFunction(listener))
    throw TypeError('listener must be a function');

  if (!this._events)
    this._events = {};

  // To avoid recursion in the case that type === "newListener"! Before
  // adding it to the listeners, first emit "newListener".
  if (this._events.newListener)
    this.emit('newListener', type,
              isFunction(listener.listener) ?
              listener.listener : listener);

  if (!this._events[type])
    // Optimize the case of one listener. Don't need the extra array object.
    this._events[type] = listener;
  else if (isObject(this._events[type]))
    // If we've already got an array, just append.
    this._events[type].push(listener);
  else
    // Adding the second element, need to change to array.
    this._events[type] = [this._events[type], listener];

  // Check for listener leak
  if (isObject(this._events[type]) && !this._events[type].warned) {
    if (!isUndefined(this._maxListeners)) {
      m = this._maxListeners;
    } else {
      m = EventEmitter.defaultMaxListeners;
    }

    if (m && m > 0 && this._events[type].length > m) {
      this._events[type].warned = true;
      console.error('(node) warning: possible EventEmitter memory ' +
                    'leak detected. %d listeners added. ' +
                    'Use emitter.setMaxListeners() to increase limit.',
                    this._events[type].length);
      if (typeof console.trace === 'function') {
        // not supported in IE 10
        console.trace();
      }
    }
  }

  return this;
};

EventEmitter.prototype.on = EventEmitter.prototype.addListener;

EventEmitter.prototype.once = function(type, listener) {
  if (!isFunction(listener))
    throw TypeError('listener must be a function');

  var fired = false;

  function g() {
    this.removeListener(type, g);

    if (!fired) {
      fired = true;
      listener.apply(this, arguments);
    }
  }

  g.listener = listener;
  this.on(type, g);

  return this;
};

// emits a 'removeListener' event iff the listener was removed
EventEmitter.prototype.removeListener = function(type, listener) {
  var list, position, length, i;

  if (!isFunction(listener))
    throw TypeError('listener must be a function');

  if (!this._events || !this._events[type])
    return this;

  list = this._events[type];
  length = list.length;
  position = -1;

  if (list === listener ||
      (isFunction(list.listener) && list.listener === listener)) {
    delete this._events[type];
    if (this._events.removeListener)
      this.emit('removeListener', type, listener);

  } else if (isObject(list)) {
    for (i = length; i-- > 0;) {
      if (list[i] === listener ||
          (list[i].listener && list[i].listener === listener)) {
        position = i;
        break;
      }
    }

    if (position < 0)
      return this;

    if (list.length === 1) {
      list.length = 0;
      delete this._events[type];
    } else {
      list.splice(position, 1);
    }

    if (this._events.removeListener)
      this.emit('removeListener', type, listener);
  }

  return this;
};

EventEmitter.prototype.removeAllListeners = function(type) {
  var key, listeners;

  if (!this._events)
    return this;

  // not listening for removeListener, no need to emit
  if (!this._events.removeListener) {
    if (arguments.length === 0)
      this._events = {};
    else if (this._events[type])
      delete this._events[type];
    return this;
  }

  // emit removeListener for all listeners on all events
  if (arguments.length === 0) {
    for (key in this._events) {
      if (key === 'removeListener') continue;
      this.removeAllListeners(key);
    }
    this.removeAllListeners('removeListener');
    this._events = {};
    return this;
  }

  listeners = this._events[type];

  if (isFunction(listeners)) {
    this.removeListener(type, listeners);
  } else if (listeners) {
    // LIFO order
    while (listeners.length)
      this.removeListener(type, listeners[listeners.length - 1]);
  }
  delete this._events[type];

  return this;
};

EventEmitter.prototype.listeners = function(type) {
  var ret;
  if (!this._events || !this._events[type])
    ret = [];
  else if (isFunction(this._events[type]))
    ret = [this._events[type]];
  else
    ret = this._events[type].slice();
  return ret;
};

EventEmitter.prototype.listenerCount = function(type) {
  if (this._events) {
    var evlistener = this._events[type];

    if (isFunction(evlistener))
      return 1;
    else if (evlistener)
      return evlistener.length;
  }
  return 0;
};

EventEmitter.listenerCount = function(emitter, type) {
  return emitter.listenerCount(type);
};

function isFunction(arg) {
  return typeof arg === 'function';
}

function isNumber(arg) {
  return typeof arg === 'number';
}

function isObject(arg) {
  return typeof arg === 'object' && arg !== null;
}

function isUndefined(arg) {
  return arg === void 0;
}

},{}]},{},[1])(1)
});